1. 程式人生 > >最大子陣列問題--分治法的思想

最大子陣列問題--分治法的思想

國外經典教材《演算法導論》P67頁提到了最大子陣列的問題,書中給出兩種解答方法,分別是暴力求解的方法,分治策略的求解方法。在杭電 ACM OJ 中也有一條類似的題目,連線如下:http://acm.hdu.edu.cn/showproblem.php?pid=1003

Max Sum

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 255763    Accepted Submission(s): 60795


Problem Description Given a sequence a[1],a[2],a[3]......a[n], your job is to calculate the max sum of a sub-sequence. For example, given (6,-1,5,4,-7), the max sum in this sequence is 6 + (-1) + 5 + 4 = 14.

Input The first line of the input contains an integer T(1<=T<=20) which means the number of test cases. Then T lines follow, each line starts with a number N(1<=N<=100000), then N integers followed(all the integers are between -1000 and 1000).

Output For each test case, you should output two lines. The first line is "Case #:", # means the number of the test case. The second line contains three integers, the Max Sum in the sequence, the start position of the sub-sequence, the end position of the sub-sequence. If there are more than one result, output the first one. Output a blank line between two cases.

Sample Input 2 5 6 -1 5 4 -7 7 0 6 -1 1 -6 7 -5
Sample Output Case 1: 14 1 4 Case 2: 7 1 6
Author Ignatius.L 題目分析:若用暴力求解的方法去做,時間複雜度會是O(n^2),會出現時間超限的問題。暴力求解程式碼如下: #include<stdio.h>
int main()
{
int T;
int n;
int i;
scanf("%d",&T);
for(i=0;i<T;i++){
scanf("%d",&n);
int *p = new int [n];
int j;
for(j=0;j<n;j++){
scanf("%d",&p[j]);
}


int best;
int sum;
int first;
int end;
int k;
best = p[0];
first = end = 0; //關鍵求解過程
for(j=0;j<n;j++){
sum = 0;
for(k=j;k<n;k++){
sum += p[k];
if(best<sum){
best = sum;
first = j;
end = k;
}
}
}
printf("Case %d:\n",i+1);
printf("%d %d %d\n",best,first+1,end+1);
delete []p;
}
return 0;
}
分治策略思想: 1.把問題儘可能劃分為規模相等的子問題。 2.遞迴求解子問題 3.合併子問題的解得到原問題的解 #include<stdio.h>
struct node{
int first;
int end;
int summax;
node(int a,int b,int c):first(a),end(b),summax(c){}
};
node maxsum(int *p,int x,int y)
{
if(y-x==1||y==x){
return node(x+1,x+1,p[x]); //只有一個數
}
int mid = (x+y)/2; //分治第一步:劃分[x,mid)和[mid,y)

node maxsl = maxsum(p,x,mid);
node maxsr = maxsum(p,mid,y); //分治第二步:遞迴求解
node maxs = maxsl.summax>=maxsr.summax?maxsl:maxsr;
int L,R,sum,i,a=mid-1,b=mid;
L = p[mid-1];
sum = 0; //分治第三步:合併(1)——從分界點開始往左求最大連續和L
for(i=mid-1;i>=x;i--){
sum+=p[i];
if(sum>=L){
L = sum;
a = i;

}
R = p[mid];
sum = 0; //分治第三步:合併(2)——從分界點開始往右求最大連續和R

for(i=mid;i<y;i++){
sum+=p[i];
if(sum>R){
R = sum;
b = i;
}
}
if(maxs.summax>L+R){
return maxs;
}
else{
return node(a+1,b+1,L+R);
}
}
int main()
{
int T,i;
scanf("%d",&T);
for(i=0;i<T;i++){
int n,j;
int *p;
scanf("%d",&n);
p = new int [n];
for(j=0;j<n;j++){
scanf("%d",&p[j]);
}
node maxs = maxsum(p,0,n);
printf("Case %d:\n",i+1);
printf("%d %d %d\n",maxs.summax,maxs.first,maxs.end);
if(i!=T-1){
printf("\n");
}
}
return 0;
}
另外網上對於該題還有動態規劃(dp)等的求解方法,連結如下:http://blog.csdn.net/hcbbt/article/details/10454947

相關推薦

大子序列 治法

static int MaxSubSum(const int a[],int Left,int Right) { int MaxLeftSum,MaxRightSum; int MaxLeftBorderSum,MaxRightBorderSum;

大子治法解法

#include <string.h> #include <stdio.h> /** * 計算 a中從 left 到 right的最大子序列 * l r為計算得到的子序列位置 */ int maxSub(int *a, int left, in

大子陣列問題--治法思想

國外經典教材《演算法導論》P67頁提到了最大子陣列的問題,書中給出兩種解答方法,分別是暴力求解的方法,分治策略的求解方法。在杭電 ACM OJ 中也有一條類似的題目,連線如下:http://acm.hdu.edu.cn/showproblem.php?pid=1003

《演算法導論》——治法求解大子陣列

《演算法導論》——分治法求解最大子陣列 最大字陣列問題即對某一陣列A,其元素有正有負,找到一個子陣列,其元素是連續的且其和最大。 #include "iostream" using namespace std; struct uin //建立返回值資料結構 { int

ADA演算法知識(七)Divide and conquer algorithm(治法解決大子陣列和問題)

[Maximum Subarry Sum] The maximum subarry sum problem takes as input an array of (positive or negative) integers a[1..n] and returns the largest sum o

治法-大子陣列問題

尋找陣列A的和最大的非空連續子陣列。例如:陣列 A = {13, -3, -25, 20, -3, -16, -23, 18, 20, -7, 12, -5, -22, 15, -4, 7}的和最大的連續子陣列為{18, 20, -7, 12},最大和為43,

治法——大子陣列

題目描述: 給定一個n個元素的陣列a,求a[i]+a[i+1]+…+a[j]的最大值(0 <= i <= j < n) 解題思路: 我們來試試用分治法來解決這個問題。首先我們想要找到一個子陣列a[i…j]為最大子陣列,我們假設陣列的中點為

治法實現大子陣列問題(Java)

終於把這個搞出來了,中間出現了好多小問題,虛擬碼和演算法思想可以參考演算法導論。package com.alibaba; public class MaxSubarray { public sta

4.1 大子陣列問題(治法)

public class MaxSubArray { //暴力求解 int maxSubArray1(int arr[]) { int max = 0;

治法求解大子陣列問題

/* 最大子陣列問題 給出每天股票的價格,求出買進和賣出的時間,使得獲利最高。 輸入: P[0~n-1] 輸出: 買進的時間i和賣出的時間j(0<=i<=j<=n-1) */ //分治法求解,將陣列P轉換為陣列A,其中A中每個元素A[i]=P

4.1 大子陣列問題(治法)-NlogN

A[low..high]的任何子陣列A[i,j]所處的位置必定是一下三種情況之一: 完全位於子陣列A[low..mid]中,low< =i<=j<=mid 完全位於子陣列A[mid

【演算法學習】大子陣列問題的治法求解

最大子陣列問題求解的是給定一個數組a[0...n-1],求出它的一個子陣列使得其所有元素的和加起來最大如果使用暴力解法即列舉所有的子陣列,則時間複雜度為O(n^2)採用分治法,對一段陣列a[low.....high],求它的最大子陣列,mid = (low+high)/ 2那

643. Maximum Average Subarray I 大子陣列平均數

bject ble height r12 for over xpl example padding Given an array consisting of n integers, find the contiguous subarray of given length k

大子陣列/連續數組的大和

HA ati pan AC () 個數 code 少包 CA 問題描述 在一個數組中找出和最大的連續幾個數(至少包含一個數)。 例如: 數組 A[] = [?2, 1, ?3, 4, ?1, 2, 1, ?5, 4],則連續的子序列[4,?1,2,1]有最大的和6。 輸入格

返回一個二維整形陣列中的大子陣列的和(隨機二維整形陣列

一、題目:返回一個二維整數陣列中的最大子陣列的和(隨機二維整形陣列) 二、課題要求: 輸入一個二維整形陣列,數組裡有正數也有負數; 二維陣列中連續的一個子矩陣組成一個子陣列,沒個子陣列都有一個和; 求所有子陣列的和的最大值,要求時間複雜度為O(n)。 三、結對程式設計要求: 兩人結對完成程式設計任

陣列-BAT面試經典試題:絕對眾數,零子陣列大子陣列

1.絕對眾數問題 定義:給定N個數,稱出現次數最多的數為眾數:若某眾數出現的次數大於N/2,稱該眾數為絕對眾數。 如:A={1,2,1,3,2}中,1和2都是眾數,但都不是絕對眾數;A={1,2,1,3,1}中,1是絕對眾數。 已知給定的N個整數存在絕對眾數,以最低的時空負責度計算該

用c++實現環形陣列大子陣列之和(結對)

結對作業 1.分解問題,將環形陣列,剪開變成一個一維陣列。 2.用一維陣列的最大子陣列和解決。 對於一個環形陣列,對每一個一維陣列的表示共有n-1種 原始碼如下: 1 #include<iostream> 2 using namespace std; 3 int max_

用c++實現環形陣列大子陣列之和

分析:   1.將環形陣列,剪開變成一個一維陣列。   2.用一維陣列的最大子陣列和解決。 對於一個環形陣列,表示成一個一維陣列總共有n種。如圖所示: 程式程式碼: 1 #include<iostream> 2 using namespace std; 3 int mai

用c++實現環形陣列大子陣列的和

分析:對環形陣列確定首元素,從而變成一位陣列。因為有n個元素,所以有n種情況 如圖: 程式程式碼: #include<iostream> using namespace std; int max_sum1(int a[],int n) { int max_sum_h=a[0

環形陣列大子陣列求解

    然後再用一維陣列求解最大子陣列的方法即可。值得注意的是,子陣列的長度不可超過n,在我程式中有所體現。最終,因為沒有要求時間複雜度的問題,我選擇 了遍歷的方法求解了此問題。 程式程式碼: 1 #include<iostream> 2 using nam